LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity part2 is
	port
	(
			CLOCK_50	 : in std_logic;
			KEY : in STD_LOGIC_VECTOR(0 downto 0);		
			HEX0 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX1 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX2 : OUT STD_LOGIC_VECTOR(0 TO 6)
	);
end;


architecture behav of part2 is
   signal d0, d1, d2 : std_logic_vector(3 downto 0);
	signal CLOCK_1s, c10s, c100s : std_logic;
begin


Count0:
   entity work.counter(behav)
	generic map(26, 50_000_000)
	port map(clock=> CLOCK_50, reset_n => KEY(0), Q => open, rollower => CLOCK_1s);

	
Count1:
   entity work.counter(behav)
	generic map(4, 10)
	port map(clock=> CLOCK_1s, reset_n => KEY(0), Q => d0, rollower => c10s);
H0: 
   entity work.DisplayDigit PORT MAP (d0, HEX0);	

Count2:
   entity work.counter(behav)
	generic map(4, 10)
	port map(clock=> c10s, reset_n => KEY(0), Q => d1, rollower => c100s);
H1: 
   entity work.DisplayDigit PORT MAP (d1, HEX1);

Count3:
   entity work.counter(behav)
	generic map(4, 10)
	port map(clock=> c100s, reset_n => KEY(0), Q => d2, rollower => open);	
H2: 
   entity work.DisplayDigit PORT MAP (d2, HEX2);	
	

end architecture;
	
	
	
