LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity part3 is
	port
	(
			CLOCK_50	 : in std_logic;
			KEY : in STD_LOGIC_VECTOR(1 downto 0);	
		   SW  : in STD_LOGIC_VECTOR(7 downto 0);	
			HEX0 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX1 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX2 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX3 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX4 : OUT STD_LOGIC_VECTOR(0 TO 6);	
			HEX5 : OUT STD_LOGIC_VECTOR(0 TO 6)			
	);
end;


architecture behav of part3 is
   signal d0, d1, d2, d3, d4, d5 : std_logic_vector(3 downto 0) := (others=>'0');
	signal c001s, c01s, c1s, c10s, c1m, c10m : std_logic;
	signal en0, en1, en2, en3, en4, en5, en6 : std_logic;
	signal r1, r2 : std_logic_vector(3 downto 0);
	signal my_nrest : std_logic;
	
begin

  
reset:  -- added this procedure to remove FF from HEX4,5
  process (CLOCK_50) is
     variable count : std_logic_vector(3 downto 0) := x"0"; 
  begin  
     if rising_edge(CLOCK_50) then
		  if count<x"f" then
				my_nrest<='0';
				count:=count+1;
		  elsif count=x"f" then
				my_nrest<=KEY(1);
		  end if;
	  end if;
  end process;

-- my_nrest<=KEY(1);

en0 <= KEY(0);
Count0:
   entity work.counter(behav)
	generic map(19, 500_000)
	port map(clock=> CLOCK_50, reset_n => my_nrest, enable=>en0, Q => open, rollover => c001s);

	
en1 <= KEY(0) and c001s;	
Count1:
   entity work.counter(behav)
	generic map(4, 10)
	port map(clock=> CLOCK_50, reset_n => my_nrest, enable=>en1, Q => d0, rollover => c01s);
H0: 
   entity work.DisplayDigit PORT MAP (d0, HEX0);	

en2 <= KEY(0) and c01s;	
Count2:
   entity work.counter(behav)
	generic map(4, 10)
	port map(clock=> CLOCK_50, reset_n => my_nrest, enable=>en2, Q => d1, rollover => c1s);
H1: 
   entity work.DisplayDigit PORT MAP (d1, HEX1);
	
en3 <= KEY(0) and c1s;
Count3:
   entity work.counter(behav)
	generic map(4, 10)
	port map(clock=> CLOCK_50, reset_n => my_nrest, enable=>en3, Q => d2, rollover => c10s);	
H2: 
   entity work.DisplayDigit PORT MAP (d2, HEX2);	
	
en4 <= KEY(0) and c10s;	
Count4:
   entity work.counter(behav)
	generic map(4, 6)
	port map(clock=> CLOCK_50, reset_n => my_nrest, enable=>en4, Q => d3, rollover => c1m);
H3: 
   entity work.DisplayDigit PORT MAP (d3, HEX3);
	
en5 <= KEY(0) and c1m;	
Count5:
   entity work.counter1(behav)
	generic map(4, 10)
	port map(clock=> CLOCK_50, loadn => my_nrest, reset_n=>'1', enable=>en5, load_val => SW(3 downto 0), Q => d4, rollover => c10m);	
H4: 
   entity work.DisplayDigit PORT MAP (d4, HEX4);

en6 <= KEY(0) and c10m;	
Count6:
   entity work.counter1(behav)
	generic map(4, 6)
	port map(clock=> CLOCK_50, loadn => my_nrest, reset_n=>'1', enable=>en6, load_val => SW(7 downto 4), Q => d5, rollover => open);	
H5: 
   entity work.DisplayDigit PORT MAP (d5, HEX5);	
	

end architecture;
	
	
	
