LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity part4 is
	port
	(
			CLOCK_50	 : in std_logic;
			KEY : in STD_LOGIC_VECTOR(1 downto 0);	
		   SW  : in STD_LOGIC_VECTOR(2 downto 0);	
			LEDR : out STD_LOGIC_VECTOR(0 downto 0)
	);
end;


architecture behav of part4 is
   CONSTANT A : STD_LOGIC_VECTOR(3 downto 0) := "0001";
   CONSTANT LEN_A : STD_LOGIC_VECTOR(2 downto 0) := "010";
   CONSTANT B : STD_LOGIC_VECTOR(3 downto 0) := "1110";
   CONSTANT LEN_B : STD_LOGIC_VECTOR(2 downto 0) := "100";
   CONSTANT C : STD_LOGIC_VECTOR(3 downto 0) := "1010";
   CONSTANT LEN_C : STD_LOGIC_VECTOR(2 downto 0) := "100";
   CONSTANT D : STD_LOGIC_VECTOR(3 downto 0) := "0110";
   CONSTANT LEN_D : STD_LOGIC_VECTOR(2 downto 0) := "011";
   CONSTANT E : STD_LOGIC_VECTOR(3 downto 0) := "0001";
   CONSTANT LEN_E : STD_LOGIC_VECTOR(2 downto 0) := "001";
   CONSTANT F : STD_LOGIC_VECTOR(3 downto 0) := "1011";
   CONSTANT LEN_F : STD_LOGIC_VECTOR(2 downto 0) := "100";
   CONSTANT G : STD_LOGIC_VECTOR(3 downto 0) := "0001";
   CONSTANT LEN_G : STD_LOGIC_VECTOR(2 downto 0) := "011";
   CONSTANT H : STD_LOGIC_VECTOR(3 downto 0) := "1111";
   CONSTANT LEN_H : STD_LOGIC_VECTOR(2 downto 0) := "100";
	signal SelectedLetter : STD_LOGIC_VECTOR(3 downto 0);
	signal SelectedLength : STD_LOGIC_VECTOR(2 downto 0);

   signal pulse_05s, resetncount1, resetncount2, enablecount2 : STD_LOGIC;
   signal phase : STD_LOGIC_VECTOR(1 downto 0);	
begin

Count0:
   entity work.counter(behav)
	generic map(25, 25_000_000)
	port map(clock=> CLOCK_50, reset_n => resetncount1, enable=>'1', Q => open, rollower => pulse_05s);
	
Count1:
   entity work.counter(behav)
	generic map(2, 4)
	port map(clock=> CLOCK_50, reset_n => resetncount2, enable=>enablecount2, Q => phase, rollower => open);	

	
SelectLetter: process (SW) is
   begin
		case SW is
			when "000" =>
				SelectedLetter <= A;
				SelectedLength <= LEN_A;
			when "001" =>
				SelectedLetter <= B;
				SelectedLength <= LEN_B;
			when "010" =>
				SelectedLetter <= C;
				SelectedLength <= LEN_C;				
			when "011" =>
				SelectedLetter <= D;
				SelectedLength <= LEN_D;
			when "100" =>
				SelectedLetter <= E;
				SelectedLength <= LEN_E;				
			when "101" =>
				SelectedLetter <= F;
				SelectedLength <= LEN_F;
			when "110" =>
				SelectedLetter <= G;
				SelectedLength <= LEN_G;
			when "111" =>
				SelectedLetter <= H;
				SelectedLength <= LEN_H;				
			end case;
	end process;
	
logic: process(CLOCK_50, KEY(0)) is
		variable ShiftReg : std_logic_vector(3 downto 0) := (others=>'0');
		variable NumChars : std_logic_vector(2 downto 0) := (others=>'0');
		variable start : std_logic := '0';
		variable wait05s : std_logic := '1';
	begin
		if KEY(0) = '0' then
		   start := '0';
			resetncount1<='0';
			resetncount2<='0';
			LEDR(0)<= '0';
			ShiftReg := (others=>'0');
			NumChars := (others=>'0');
		elsif rising_edge(CLOCK_50) then
			resetncount1<='1';
			resetncount2<='1';	
			if KEY(1)='0' then
			   start := '1';
				resetncount2<='0';
				enablecount2<='0';
				ShiftReg:=SelectedLetter;
				NumChars:=SelectedLength;
				LEDR(0) <= '0';
			elsif start='1' then
			   if (pulse_05s='1') then
					enablecount2<='1';
					LEDR(0) <= '1';
					if (phase="01" and ShiftReg(0) = '1') or (phase="11" and ShiftReg(0) = '0') then
						-- spegni led e carica prossimo carattere se serve
						LEDR(0) <= '0';
						ShiftReg(2 downto 0) := ShiftReg(3 downto 1);
						ShiftReg(3) := '0';
						NumChars := NumChars-1;
						resetncount2<='0';						
					end if;
				else
					if NumChars=0 then
						start :='0';
						resetncount2<='0';
						enablecount2<='0';
						LEDR(0)<='0';
					else
						enablecount2<='0';
						resetncount2<='1';	
					end if;
				end if;
			end if;
		end if;
	end process;
	

end architecture;
	
	
	
